#include "script_trigger.h"


ScriptTrigger::ScriptTrigger()
{
 scriptCalled = false;
}

ScriptTrigger::~ScriptTrigger()
{

}

void ScriptTrigger::loadParams(const TiXmlElement* root)
{
   /* LoadParam(root, "file", this, ScriptTrigger, setScript)
        .describe("the fileName of the script, that should be triggered by this script trigger")
        .defaultValues("");
    LoadParam(root, "function", this, ScriptTrigger, setFunction)
        .describe("the function of the script, that should be triggered by this script trigger")
        .defaultValues("");
    LoadParam(root, "abs-coor", this, ScriptTrigger, setAbsCoord)
        .describe("the fileName of the script, that should be triggered by this script trigger")
        .defaultValues("");
    LoadParam(root, "radius", this, ScriptTrigger, setRadius)
        .describe("the fileName of the script, that should be triggered by this script trigger")
        .defaultValues("");
    */
}



void ScriptTrigger::tick(float timestep)
{

 if((this->getAbsDirV()-target->getAbsDirV()).len() < radius)
 {
  if(!callOnce)
   {
    executeAction();
   }
  else if(callOnce && !scriptCalled)
  {
   executeAction();
   scriptCalled = true;
  }
 }

}



void ScriptTrigger::executeAction()
{
     ScriptManager* scriptManager = ScriptManager::getInstance();
     Script* script = scriptManager->getScriptByFile(this->scriptFile);
     if(!(script->selectFunction(this->functionName,0)) )
       printf("Error: Selection of %s in %s failed.\n",functionName.c_str(), scriptFile.c_str());
     if( !(script->executeFunction()) )
       printf("Execution of %s in %s failed\n",functionName.c_str(),scriptFile.c_str());
}
